<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2011 Manfred Egger <em@bluechip.at>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *  A copy is found in the textfile GPL.txt and important notices to the license
 *  from the author is found in LICENSE.txt distributed with these scripts.
 *
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Dummy document - displays nothing but background color.
 *
 * $Id: dummy.php 3439 2008-03-16 19:16:51Z flyguide $
 * Revised for TYPO3 3.6 2/2003 by Kasper Skaarhoj
 * XHTML compliant content
 *
 * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
 */
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *   68: class SC_dummy
 *   76:     function main()
 *   92:     function printContent()
 *
 * TOTAL FUNCTIONS: 2
 * (This index is automatically created/updated by the extension "extdeveval")
 *
 */
if (!preg_match('/typo3conf/', $_SERVER['PHP_SELF'])) {
	$BACK_PATH = '../../';
	define('TYPO3_MOD_PATH', 'ext/bc_post2facebook/lib/');
} else {
	$BACK_PATH = '../../../../typo3/';
	define('TYPO3_MOD_PATH', '../typo3conf/ext/bc_post2facebook/lib/');
}

require($BACK_PATH . 'init.php');
require($BACK_PATH . 'template.php');
require_once(PATH_t3lib . 'class.t3lib_page.php');
require_once(PATH_t3lib . 'class.t3lib_tstemplate.php');
require_once(PATH_t3lib . 'class.t3lib_tsparser_ext.php');
require_once(PATH_tslib.'class.tslib_fe.php');
require_once(PATH_t3lib.'class.t3lib_userauth.php');
require_once(PATH_tslib.'class.tslib_feuserauth.php');
require_once(PATH_t3lib.'class.t3lib_cs.php');
require_once(PATH_tslib.'class.tslib_content.php');
require_once(PATH_t3lib.'class.t3lib_timetrack.php');
require_once(t3lib_extMgm::extPath('bc_post2facebook') . 'lib/class.tx_bc_post2facebook_div.php');
require_once(t3lib_extMgm::extPath('bc_post2facebook') . 'lib/facebook/class.tx_bc_post2facebook_facebook.php');
require_once(t3lib_extMgm::extPath('bc_post2facebook') . 'lib/class.tx_bc_post2facebook_cobj.php');

/**
 * Script Class, creating the content for the dummy script - which is just blank output.
 *
 * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
 * @package TYPO3
 * @subpackage core
 */
class tx_bc_post2facebook_wizard {

	// GET vars:
	var $P; // Wizard parameters, coming from TCEforms linking to the wizard.
	var $fieldChangeFunc; // Serialized functions for changing the field... Necessary to call when the value is transferred to the TCEform since the form might need to do internal processing. Otherwise the value is simply not be saved.
	var $fieldName;  // Form name (from opener script)
	var $formName;  // Field name (from opener script)
	var $md5ID;   // ID of element in opener script for which to set color.
	var $conf;
	var $apiKey;
	/**
	 * document template object
	 *
	 * @var smallDoc
	 */
	var $doc;
	var $content; // Accumulated content.

	function post2facebook($row, $config, $values) {
		global $LANG;

		$attachment = array('access_token' => $this->bcFacebook->token);
		$attachmentOverrule = array();
		
		foreach($values as $key=>$value) {
			if(trim($value)) {
				if(!tx_bc_post2facebook_div::StartsWith($key,'_')) {
					$attachment[$key] = $value;
				} else {
					$attachmentOverrule[substr($key, 1)] = $value;
				}
			}
		}

		$attachment = t3lib_div::array_merge_recursive_overrule($attachment, $attachmentOverrule);

		$id = t3lib_div::trimExplode('_', $config['id']);

		$ok = false;
		switch($id[0]) {
			case 'page':
				if($this->fbAppSettings['postAsPage']=='yes' && $this->bcFacebook->tokens[$id[1]]) {
					$attachment['access_token'] = $this->bcFacebook->tokens[$id[1]];
				}
			case 'group':
			case 'profile':
				$ok = true;
				break;
		}
		try {
			if($ok) {
				$ids[] = $this->bcFacebook->facebook->api('/' . $id[1] . '/' . ($config['postAs'] ? $config['postAs'] : 'feed'), 'post', $attachment);
			}
		} catch(Exception $ex) {
			$error = $ex;
		}
		if(count($ids)) {
			$fieldName = $config['fieldName'] ? $config['fieldName'] : 'tx_bcpost2facebook_facebook_id';
			$update = t3lib_div::trimExplode(',', $row[$fieldName], 1);
			foreach($ids as $id) {
				$update[] = $id['id'];
			}
			$res = $GLOBALS['TYPO3_DB']->exec_UPDATEquery($this->P['table'],'uid='.$this->P['uid'],array($fieldName=>implode(',',$update)));
			$GLOBALS['TYPO3_DB']->sql_free_result($res);

			return tx_bc_post2facebook_div::message($LANG->getLL('wizard.success'),$LANG->getLL('wizard.information'),'message-ok');
		} else {
			$ret = $LANG->getLL('wizard.postError');
			if($error) {
				$ret .= ' '.$LANG->getLL('wizard.postErrorMessage').'<br />'.$error;
			}
			return $this->error($ret);
		}
	}

	/**
	 * Create content for the dummy script - outputting a blank page.
	 *
	 * @return	void
	 */
	function main() {
		global $LANG, $BACK_PATH;

		$this->P = t3lib_div::_GP('P');
		$div = t3lib_div::makeInstance('tx_bc_post2facebook_div');
		$div->initTSFE($this->P['pid']);
		$this->fbAppSettings = $div->getConfig($this->P['pid']);
		$this->fbAppSettings['appUrl'] = $div->normalizeWebUrl($this->fbAppSettings['appUrl']);


		$this->bcFacebook = t3lib_div::makeInstance('tx_bc_post2facebook_facebook');
		$this->bcFacebook->initFacebook($this->fbAppSettings);
		$tokenFound = $this->bcFacebook->get_check_session();

		$this->doc = t3lib_div::makeInstance('template');
		$this->doc->backPath = $BACK_PATH;
		$this->doc->docType = 'xhtml_trans';

		$this->doc->inDocStyles = '
		  body { padding: 10px; }

		  #formContainer {
			padding: 5px 10px;
			background-color: '.$this->doc->bgColor2.'
		  }
		  #formContainer table {
			width: 100%;
		  }
		  ';
		$this->content.=$this->doc->startPage($LANG->getLL('wizard.title'));
		$this->content.=$this->doc->header($LANG->getLL('wizard.title'));
		$this->content.=$this->doc->spacer(5);
		$this->content.=$this->doc->divider(5);
		if (!$tokenFound) {
			$this->content .= $this->error($LANG->getLL('wizard.noToken'));
		} elseif (!$this->fbAppSettings['config.'][$this->P['table'].'.']) {
			$this->content .= $this->error($LANG->getLL('wizard.noConfig'));
		} else {
			$post = t3lib_div::_GP('tx_bc_post2facebook');
			$post_conf = t3lib_div::_GP('tx_bc_post2facebook_conf');
			if($post && $post_conf && $post['submit']) {
				$this->content .= $this->post2facebook($row, $post, $post_conf);
			} else {
				$content .= $this->getSelectionForm();
				$content .= $this->getPreviewForm($this->fbAppSettings['config.'][$this->P['table'].'.']);
				$this->content .= '<form method="post">'.$content.'</form>';
			}
		}
	}

	function getPreviewForm(&$lConf) {
		global $LANG;
		$rec = $this->getRecordInfo($lConf);
		$content = '';
		$lines = array();
		foreach($rec as $key=>$value) {
			if(is_array($value)) {
				$line = '<tr><td>'.$key.':</td><td><table cellpadding="2">';
				$line1 = '<tr><td align="center"><img src="'.$value['selected']['absolute'].'" /></td>';
				$line2 = '<tr><td align="center"><input type="radio" name="tx_bc_post2facebook_conf['.$value['selected']['key'].']" checked="checked" value="'.$value['selected']['value'].'" /></td>';
				if(count($value['other'])) {
					foreach($value['other'] as $img) {
						$line1 .= '<td align="center"><img src="'.$img['absolute'].'" /></td>';
						$line2 .= '<td align="center"><input type="radio" name="tx_bc_post2facebook_conf['.$img['key'].']"  value="'.$img['value'].'" /></td>';
					}
				}
				$line1 .= '<td align="center" style="padding: 1em 3em;vertical-align:middle;">'.$LANG->getLL('wizard.noImage').'</td></tr>';
				$line2 .= '<td align="center"><input type="radio" name="tx_bc_post2facebook_conf['.$key.']" value="" /></td></tr>';

				if(!$lConf['_config.']['picture_as_upload']) {
					$line3 ='<tr><td colspan="'.(count($value['other'])+2).'">'.$LANG->getLL('wizard.ownImage').'<br /><input type="text" '.$this->doc->formWidth().' name="tx_bc_post2facebook_conf[_'.$key.']" /></td></tr>';
				}

				$line .= $line1.$line2.$line3.'</table></td></tr>';
				$lines[] = $line;
			} else {
				if(strlen($value)>60 && !preg_match('/^(?:http|ftp)s?|s(?:ftp|cp):/', $value)) {
					$rows = intval(strlen($value) / 80)+2;
					$lines[] = '<tr><td>'.$key.':</td><td><textarea name="tx_bc_post2facebook_conf['.$key.']" '.$this->doc->formWidth(48,1).' rows="'.$rows.'">'.$value.'</textarea></td></tr>';
				} else {
					$lines[] = '<tr><td>'.$key.':</td><td><input type="text" name="tx_bc_post2facebook_conf['.$key.']" '.$this->doc->formWidth().' value="'.$value.'" /></td></tr>';
				}
			}
		}

		$lines[] = '<tr><td>&nbsp;</td><td><input type="submit" name="tx_bc_post2facebook[submit]" value="'.$LANG->getLL('wizard.post').'" /></td></tr>';
		$content = '<table cellpadding="2">'.implode('', $lines).'</table>';
		foreach($lConf['_config.'] as $key=>$value) {
			$content .= '<input type="hidden" name="tx_bc_post2facebook['.$key.']" value="'.$value.'" />';
		}
		return $this->doc->section($LANG->getLL('wizard.headerPreview'), $content, 0, 1);
	}

	function error($message) {
		global $LANG;
		return tx_bc_post2facebook_div::message($message, $LANG->getLL('wizard.Error'), 'message-error');
	}

	function getImagePath($img, $key, $lConf) {
		$url = $this->fbAppSettings['webUrl'].tx_bc_post2facebook_div::getRelativePath($img, t3lib_div::getIndpEnv('TYPO3_DOCUMENT_ROOT').t3lib_div::getIndpEnv('TYPO3_SITE_PATH'));
		return array(
			'orig' => $img,
			'absolute' => $url,
			'value' => ($lConf['_config.']['picture_as_upload'] ? '@'.$img : $url),
			'key' => ($lConf['_config.']['picture_as_upload'] ? '@'.basename($img) : $key),
		);
	}

	function getRecordInfo(&$lConf) {

		$rec = array();
		$where = 'uid=' . $this->P['uid'];
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', $this->P['table'], $where);

		if ($res && $GLOBALS['TYPO3_DB']->sql_num_rows($res)) {
			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
			$GLOBALS['TYPO3_DB']->sql_free_result($res);

			$row['_url'] = $this->fbAppSettings['webUrl'];

			$local_cObj = new tx_bc_post2facebook_cObj();
			$local_cObj->start($row);

			if($lConf['_config.']['contentFromForeignTable']) {
				$conf = $lConf['_config.']['contentFromForeignTable.'];
				$table = isset($conf['table.'])
					? $local_cObj->stdWrap($conf['table'], $conf['table.'])
					: $conf['table'];
				$source = isset($conf['source.'])
					? $local_cObj->stdWrap($conf['source'], $conf['source.'])
					: $conf['source'];

				if($table && $source) {
					$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', $table, 'uid='.intval($source));

					if ($res && $GLOBALS['TYPO3_DB']->sql_num_rows($res)) {
						foreach($row as $key=>$value) {
							$GLOBALS['TSFE']->register['post2facebook_parentRec.'.$key] = $value;
						}
						$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
						$local_cObj->start($row);
						$GLOBALS['TYPO3_DB']->sql_free_result($res);
					}
				}
			}

			$images = t3lib_div::trimExplode(',', $row[$lConf['_config.']['picture_field']]);
			$GLOBALS['TSFE']->register['picture_num'] = 0;

			foreach($lConf as $key=>$value) {
				if(strtoupper($lConf[$key]) == 'NONE' || empty($lConf[$key]) || tx_bc_post2facebook_div::EndsWith($key,'.') || tx_bc_post2facebook_div::StartsWith($key,'_')) continue;
				$rec[$key] = $local_cObj->cObjGetSingle($lConf[$key], $lConf[$key.'.']);
				if($lConf[$key] == 'IMG_RESOURCE') {
					$temp = $rec[$key];
					$rec[$key] = array();
					$rec[$key]['selected'] = $this->getImagePath($temp, $key, $lConf);
					if(count($images)>1){
						for($i=1;$i<min(count($images),10);$i++) {
							$GLOBALS['TSFE']->register['picture_num'] = $i;
							$temp = $local_cObj->cObjGetSingle($lConf[$key], $lConf[$key.'.']);
							if($temp) {
								$rec[$key]['other'][$i] = $this->getImagePath($temp, $key, $lConf);
							}
						}
					}
				}
			}
		}

		return $rec;
	}

	protected function initAllowedTargets() {
		$matched = preg_match_all('/((pages|groups)({([^}]*?)})?|all|none)/', $this->fbAppSettings['displayListing'], $matches);
		$this->allowed = array();
		if($matched && !in_array('all', $matches[0]) && !in_array('none', $matches[0])) {
			if(count($matches[0])) {
				for($i=0; $i<count($matches[0]); $i++) {
					if($matches[2][$i]=='profile' || $matches[0][$i]=='profile') {
						$this->allowed['profile'] = 1;
					} elseif(strpos($matches[0][$i],'{')) {
						$this->allowed[$matches[2][$i]] = t3lib_div::trimExplode(',', $matches[4][$i], true);
					} else {
						$this->allowed[$matches[0][$i]] = 1;
					}
				}
			}
		} elseif(in_array('all', $matches[0])) {
			$this->allowed = array('pages' => 1, 'groups' => 1, 'profile' => 1);
		};
	}

	protected function isTargetAllowed($type, $id='') {
		if(
			(
				!empty($id) &&
				is_array($this->allowed[$type]) &&
				in_array($id, $this->allowed[$type])
			) ||
			(
				!is_array($this->allowed[$type]) &&
				$this->allowed[$type]
			)
		  ) {
			return true;
		}
		return false;
	}

	function getOptions(array &$out, array $options, $label) {
		if(count($options)) {
			uasort($options, array($this, 'compare'));
			$out[] = '<optgroup label="'.$label.'">';
			foreach($options as $opt) {
				$out[] = $opt[1];
			}
			$out[] = '</optgroup>';
		}
	}


	function getSelectionForm() {
		global $LANG;
		$this->initAllowedTargets();
		if(count($this->allowed)) {
			$options = array();
			$optPages = array();
			$optGroups = array();

			$count = 0;

			foreach($this->bcFacebook->tokens['account_info'] as $token) {
				if($token['category']=='Application' || !$this->isTargetAllowed('pages',$token['id'])) {
					continue;
				}
				$selected = $this->fbAppSettings['pageId']==$token['id'] ? ' selected="selected"' : '';
				$optPages[] = array($token['name'],'<option value="page_'.$token['id'].'"'.$selected.'>'.$token['name'].'</option>');
				$count++;
			}

			foreach($this->bcFacebook->tokens['group_info'] as $token) {
				if(!$token['administrator'] || !$this->isTargetAllowed('groups',$token['id'])) {
					continue;
				}
				$selected = $this->fbAppSettings['groupId']==$token['id'] ? ' selected="selected"' : '';
				$optGroups[] = array($token['name'],'<option value="group_'.$token['id'].'"'.$selected.'>'.$token['name'].'</option>');
				$count++;
			}

			if($this->isTargetAllowed('profile')) {
				$options[] = '<option value="profile_me">'.$LANG->getLL('wizard.profile').'</option>';
				$count++;
			}
			
			$this->getOptions($options, $optPages, $LANG->getLL('wizard.pages'));
			$this->getOptions($options, $optGroups, $LANG->getLL('wizard.groups'));

			$content = $LANG->getLL('wizard.selectId').'<br />';
			$content .= '<select name="tx_bc_post2facebook[id]" '.$this->doc->formWidth(35).'>'.implode('',$options).'</select>';
			
			return $this->doc->section($LANG->getLL('wizard.header1'), $content, 0, 1);
		} else {
			// If no select box should be displayed, use the default values
			// Order: first page, then group, then profile
			return '<input type="hidden" name="tx_bc_post2facebook[id]" value="'.(
					$this->fbAppSettings['pageId'] ? 'page_'.$this->fbAppSettings['pageId'] :
						($this->fbAppSettings['groupId'] ? 'group_'.$this->fbAppSettings['groupId'] : 'profile_me')
					).'" />';
		}
	}

	private function compare ($a, $b) {
		return strnatcmp($a[0],$b[0]); // or other function/code
	}

	/**
	 * Outputting the accumulated content to screen
	 *
	 * @return	void
	 */
	function printContent() {
		$this->content.= $this->doc->endPage();
		$this->content = $this->doc->insertStylesAndJS($this->content);
		echo $this->content;
	}

}

// Include extension?
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/bc_post2facebook/class.tx_bc_post2facebook_wizard.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/bc_post2facebook/lib/class.tx_bc_post2facebook_wizard.php']);
}




// Make instance:
$SOBE = t3lib_div::makeInstance('tx_bc_post2facebook_wizard');
$SOBE->main();
$SOBE->printContent();
?>