<?php
/**
 * Copyright 2011 Facebook, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain
 * a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

require_once(t3lib_extMgm::extPath('bc_post2facebook') . 'lib/facebook/facebook_graph.php');

class BcPost2Facebook extends BC_Facebook {
	public function __construct($config) {
		parent::__construct($config);
	}
	
	/**
	* Makes an HTTP request. This method can be overridden by subclasses if
	* developers want to do fancier things or use something other than curl to
	* make the request.
	*
	* @param string $url The URL to make the request to
	* @param array $params The parameters to use for the POST body
	* @param CurlHandler $ch Initialized curl handle
	*
	* @return string The response text
	*/
	protected function makeRequest($url, $params, $ch=null) {	
		$opts = BC_BaseFacebook::$CURL_OPTS;
		if ($this->getFileUploadSupport()) {
			$opts[CURLOPT_POSTFIELDS] = $params;
		} else {
			$opts[CURLOPT_POSTFIELDS] = http_build_query($params, null, '&');
		}
		$result = tx_bc_post2facebook_facebook::getUrl($url, $opts, $ch);
		return $result;
	}
}
?>